//
//
// Description: eigen mode view data
//
// Author:  <Van Dung NGUYEN>, (C) 2013
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef EIGENMODEFIELD_H_
#define EIGENMODEFIELD_H_

#include "unknownField.h"
#include "numericalFunctions.h"
#include "eigenSolver.h"

class eigenVectorField : public unknownField{
 protected:
  eigenSolver* _eigenSolver;
  int _num;
 public:
  eigenVectorField(nonLinearMechSolver* sl,
                   const int nc, std::vector<unknownField::archiveNode> &archiving,
                   std::vector<nlsField::dataBuildView> &dbview_,
                   eigenSolver* eig, int num, const std::string file = "eigenMode");
  virtual ~eigenVectorField(){};
  virtual void get(Dof &D,double &udof) const;
  virtual void get(std::vector<Dof> &R, std::vector<double> &disp) const;
  virtual void get(std::vector<Dof> &R, fullVector<double> &disp) const;
  virtual void get(FunctionSpaceBase *sp1,FunctionSpaceBase *sp2, MInterfaceElement *iele,std::vector<double> &udofs){};
//  For archiving
  virtual void get(partDomain *dom, MElement *ele,std::vector<double> &udofs, const int cc,
                   const ElemValue ev=crude)const;
  virtual void archive(const double time,const int step, const bool forceView);
  virtual void setInitial(const std::vector<Dof> &R,const std::vector<double> &disp);
};



#endif // EIGENMODEFIELD_H_
