//
// Description: storing class for j2 linear elasto-plastic law
//
//
// Author:  <Gauthier BECKER>, (C) 2011
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ipAnisotropic.h"
#include "restartManager.h"
IPAnisotropic::IPAnisotropic() : IPVariableMechanics(), _elasticEnergy(0.) {};
IPAnisotropic::IPAnisotropic(const IPAnisotropic &source) : IPVariableMechanics(source), _elasticEnergy(source._elasticEnergy){}
IPAnisotropic& IPAnisotropic::operator=(const IPVariable &source)
{
  IPVariableMechanics::operator=(source);
  const IPAnisotropic* src = dynamic_cast<const IPAnisotropic*>(&source);
	if (src!=NULL){
		_elasticEnergy = src->_elasticEnergy;
	}
	return *this;
}

double IPAnisotropic::defoEnergy() const
{
  return _elasticEnergy;
}

void IPAnisotropic::restart()
{
  IPVariableMechanics::restart();
  restartManager::restart(_elasticEnergy);
  return;
}

