//
// Description: storing class for cluster law
//
//
// Author:  <Kevin Spilker>, (C) 2019
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ipCluster.h"
#include "restartManager.h"
IPCluster::IPCluster() : IPVariableMechanics() {Msg::Error("Cannot construct default IPCluster");}

IPCluster::IPCluster(const IPCluster &source) : IPVariableMechanics(source), _clusterNb(source._clusterNb)
{
  if(source._ipv!=NULL)
  {
    _ipv=source._ipv->clone();
  }

}
IPCluster& IPCluster::operator=(const IPVariable &source)
{
  IPVariableMechanics::operator=(source);
  const IPCluster* src = dynamic_cast<const IPCluster*>(&source);
	if (src != NULL){
	  _clusterNb = src->_clusterNb;
          if(src->_ipv!=NULL)
          {
            if(_ipv!=NULL) delete _ipv;
            _ipv=src->_ipv->clone();
          }
	}
	return *this;
}

void IPCluster::restart()
{
  IPVariableMechanics::restart();
  _ipv->restart();
  restartManager::restart(_clusterNb);
  return;
}

IPCluster::IPCluster(int clusterNb, IPVariable *ip) : IPVariableMechanics(), _clusterNb(clusterNb), _ipv(ip) 
{

}

