//
// Description: storing class for cluster material law 
// Author:  <Kevin Spilker>, (C) 2019
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef IPCLUSTER_H_
#define IPCLUSTER_H_
#include "ipvariable.h"
#include "STensor3.h"
class IPCluster : public IPVariableMechanics
{
 protected:
   int _clusterNb;
   IPVariable* _ipv; //underlying law ipv  
 public:
  IPCluster(int clnb,IPVariable* ip);
  IPCluster(const IPCluster &source);
  IPCluster& operator=(const IPVariable &source);
  virtual int getClusterNb() const { return _clusterNb;};
  virtual void restart();
  virtual IPVariable* clone() const {return new IPCluster(*this);};
  virtual ~ IPCluster()
  {
    delete _ipv;
  }
  const IPVariable *getConstRefToIPv() const {return _ipv;}
        IPVariable *getRefToIPv() {return _ipv;}

 private:
  IPCluster();
};

#endif // IPCLUSTER_H_
