//
// C++ Interface: terms
//
// Description: Class to compute Internal point
//
//
// Author:  <Gauthier BECKER>, (C) 2010
// <Van Dung NGUYEN>, (C) 2019
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ipField.h"
#include "mlaw.h"
#include "ipstate.h"
#include "nonLinearMechSolver.h"
#include "nlsFunctionSpace.h"
#include "energyField.h"
#include "numericalMaterial.h"
#include "ipFiniteStrain.h"

std::string IPField::ToString(const int i){
  if (i == SVM) return "SVM";
  else if (i == SIG_XX) return "SIG_XX";
  else if (i == SIG_YY) return "SIG_YY";
  else if (i == SIG_ZZ) return "SIG_ZZ";
  else if (i == SIG_XY) return "SIG_XY";
  else if (i == SIG_YZ) return "SIG_YZ";
  else if (i == SIG_XZ) return "SIG_XZ";
  else if (i == DAMAGE) return "DAMAGE";
  else if (i == PLASTICSTRAIN) return "PLASTICSTRAIN";
  else if (i == GL_EQUIVALENT_STRAIN) return "GL_EQUIVALENT_STRAIN";
  else if (i == STRAIN_XX) return "STRAIN_XX";
  else if (i == STRAIN_YY) return "STRAIN_YY";
  else if (i == STRAIN_ZZ) return "STRAIN_ZZ";
  else if (i == STRAIN_XY) return "STRAIN_XY";
  else if (i == STRAIN_YZ) return "STRAIN_YZ";
  else if (i == STRAIN_XZ) return "STRAIN_XZ";
  else if (i == HIGHSTRAIN_NORM) return "HIGHSTRAIN_NORM";
  else if (i == HIGHSTRESS_NORM) return "HIGHSTRESS_NORM";
  else if (i == GL_NORM) return "GL_NORM";
  else if (i == STRESS_NORM) return "STRESS_NORM";
  else if (i == P_STRESS_NORM) return "P_STRESS_NORM";
  else if (i == F_XX) return "F_XX";
  else if (i == F_XY) return "F_XY";
  else if (i == F_XZ) return "F_XZ";
  else if (i == F_YX) return "F_YX";
  else if (i == F_YY) return "F_YY";
  else if (i == F_YZ) return "F_YZ";
  else if (i == F_ZX) return "F_ZX";
  else if (i == F_ZY) return "F_ZY";
  else if (i == F_ZZ) return "F_ZZ";
  else if (i == P_XX) return "P_XX";
  else if (i == P_XY) return "P_XY";
  else if (i == P_XZ) return "P_XZ";
  else if (i == P_YX) return "P_YX";
  else if (i == P_YY) return "P_YY";
  else if (i == P_YZ) return "P_YZ";
  else if (i == P_ZX) return "P_ZX";
  else if (i == P_ZY) return "P_ZY";
  else if (i == P_ZZ) return "P_ZZ";
  else if (i == G_XXX) return "G_XXX";
  else if (i == G_XXY) return "G_XXY";
  else if (i == G_XXZ) return "G_XXZ";
  else if (i == G_XYX) return "G_XYX";
  else if (i == G_XYY) return "G_XYY";
  else if (i == G_XYZ) return "G_XYZ";
  else if (i == G_XZX) return "G_XZX";
  else if (i == G_XZY) return "G_XZY";
  else if (i == G_XZZ) return "G_XZZ";
  else if (i == G_YXX) return "G_YXX";
  else if (i == G_YXY) return "G_YXY";
  else if (i == G_YXZ) return "G_YXZ";
  else if (i == G_YYX) return "G_YYX";
  else if (i == G_YYY) return "G_YYY";
  else if (i == G_YYZ) return "G_YYZ";
  else if (i == G_YZX) return "G_YZX";
  else if (i == G_YZY) return "G_YZY";
  else if (i == G_YZZ) return "G_YZZ";
  else if (i == G_ZXX) return "G_ZXX";
  else if (i == G_ZXY) return "G_ZXY";
  else if (i == G_ZXZ) return "G_ZXZ";
  else if (i == G_ZYX) return "G_ZYX";
  else if (i == G_ZYY) return "G_ZYY";
  else if (i == G_ZYZ) return "G_ZYZ";
  else if (i == G_ZZX) return "G_ZZX";
  else if (i == G_ZZY) return "G_ZZY";
  else if (i == G_ZZZ) return "G_ZZZ";
  else if (i == Q_XXX) return "Q_XXX";
  else if (i == Q_XXY) return "Q_XXY";
  else if (i == Q_XXZ) return "Q_XXZ";
  else if (i == Q_XYX) return "Q_XYX";
  else if (i == Q_XYY) return "Q_XYY";
  else if (i == Q_XYZ) return "Q_XYZ";
  else if (i == Q_XZX) return "Q_XZX";
  else if (i == Q_XZY) return "Q_XZY";
  else if (i == Q_XZZ) return "Q_XZZ";
  else if (i == Q_YXX) return "Q_YXX";
  else if (i == Q_YXY) return "Q_YXY";
  else if (i == Q_YXZ) return "Q_YXZ";
  else if (i == Q_YYX) return "Q_YYX";
  else if (i == Q_YYY) return "Q_YYY";
  else if (i == Q_YYZ) return "Q_YYZ";
  else if (i == Q_YZX) return "Q_YZX";
  else if (i == Q_YZY) return "Q_YZY";
  else if (i == Q_YZZ) return "Q_YZZ";
  else if (i == Q_ZXX) return "Q_ZXX";
  else if (i == Q_ZXY) return "Q_ZXY";
  else if (i == Q_ZXZ) return "Q_ZXZ";
  else if (i == Q_ZYX) return "Q_ZYX";
  else if (i == Q_ZYY) return "Q_ZYY";
  else if (i == Q_ZYZ) return "Q_ZYZ";
  else if (i == Q_ZZX) return "Q_ZZX";
  else if (i == Q_ZZY) return "Q_ZZY";
  else if (i == Q_ZZZ) return "Q_ZZZ";
  else if (i == MTX_SVM) return "MTX_SVM";
  else if (i == MTX_SIG_XX) return "MTX_SIG_XX";
  else if (i == MTX_SIG_YY) return "MTX_SIG_YY";
  else if (i == MTX_SIG_ZZ) return "MTX_SIG_ZZ";
  else if (i == MTX_SIG_XY) return "MTX_SIG_XY";
  else if (i == MTX_SIG_YZ) return "MTX_SIG_YZ";
  else if (i == MTX_SIG_XZ) return "MTX_SIG_XZ";
  else if (i == INC_SVM) return "INC_SVM";
  else if (i == INC_SIG_XX) return "INC_SIG_XX";
  else if (i == INC_SIG_YY) return "INC_SIG_YY";
  else if (i == INC_SIG_ZZ) return "INC_SIG_ZZ";
  else if (i == INC_SIG_XY) return "INC_SIG_XY";
  else if (i == INC_SIG_YZ) return "INC_SIG_YZ";
  else if (i == INC_SIG_XZ) return "INC_SIG_XZ";
  else if (i == TEMPERATURE) return "TEMPERATURE";
  else if (i == THERMALFLUX_X) return "THERMALFLUX_X";
  else if (i == THERMALFLUX_Y) return "THERMALFLUX_Y";
  else if (i == THERMALFLUX_Z) return "THERMALFLUX_Z";
  else if (i == VOLTAGE) return "VOLTAGE";
  else if (i == ELECTRICALFLUX_X) return "ELECTRICALFLUX_X";
  else if (i == ELECTRICALFLUX_Y) return "ELECTRICALFLUX_Y";
  else if (i == ELECTRICALFLUX_Z) return "ELECTRICALFLUX_Z";
  else if (i == LOCAL_POROSITY) return "LOCAL_POROSITY";
  else if (i == NONLOCAL_POROSITY) return "NONLOCAL_POROSITY";
  else if (i == CORRECTED_POROSITY) return "CORRECTED_POROSITY";
  else if (i == YIELD_POROSITY) return "YIELD_POROSITY";
	else if (i == NUCLEATED_POROSITY) return "NUCLEATED_POROSITY";
	else if (i == NUCLEATION_ONSET) return "NUCLEATION_ONSET";
  else if (i == PRESSION) return "PRESSION";
  else if (i == PLASTIC_POISSON_RATIO) return "PLASTIC_POISSON_RATIO";
  else if (i == PLASTICSTRAIN_COMPRESSION) return "PLASTICSTRAIN_COMPRESSION";
  else if (i == PLASTICSTRAIN_TRACTION) return "PLASTICSTRAIN_TRACTION";
  else if (i == PLASTICSTRAIN_SHEAR) return "PLASTICSTRAIN_SHEAR";
  else if (i == NONLOCAL_PLASTICSTRAIN) return "NONLOCAL_PLASTICSTRAIN";
  else if (i == BACKSTRESS) return "BACKSTRESS";
  else if (i == JACOBIAN) return "JACOBIAN";
  else if (i == ELASTIC_JACOBIAN) return "ELASTIC_JACOBIAN";
  else if (i == PLASTIC_JACOBIAN) return "PLASTIC_JACOBIAN";
  else if (i == PLASTIC_RATE) return "PLASTIC_RATE";
  else if (i == FLOW_FACTOR_RATE) return "FLOW_FACTOR_RATE";
  else if (i == OCTAHEDRAL_SHEAR_STRAIN_RATE) return "OCTAHEDRAL_SHEAR_STRAIN_RATE";
  else if (i == OCTAHEDRAL_NORM_STRAIN_RATE) return "OCTAHEDRAL_NORM_STRAIN_RATE";
  else if (i == K_XX) return "K_XX";
  else if (i == K_YY) return "K_YY";
  else if (i == K_ZZ) return "K_ZZ";
  else if (i == K_XY) return "K_XY";
  else if (i == K_YZ) return "K_YZ";
  else if (i == K_XZ) return "K_XZ";
  else if (i == FAILURE_ONSET) return "FAILURE_ONSET";
  else if (i == GL_EQUIVALENT_STRAIN_RATE) return "GL_EQUIVALENT_STRAIN_RATE";
  else if (i == NONLOCAL_FAILURE_PLASTICSTRAIN) return "NONLOCAL_FAILURE_PLASTICSTRAIN";
  else if (i == FAILURE_PLASTICSTRAIN) return "FAILURE_PLASTICSTRAIN";
  else if (i == DAMAGE_0) return "DAMAGE_0";
  else if (i == DAMAGE_1) return "DAMAGE_1";
  else if (i == LOCAL_EQUIVALENT_STRAINS) return "LOCAL_EQUIVALENT_STRAINS";
  else if (i == NONLOCAL_EQUIVALENT_STRAINS)  return "NONLOCAL_EQUIVALENT_STRAINS";
  else if (i == FIRST_PRINCIPAL_STRESS) return "FIRST_PRINCIPAL_STRESS";
  else if (i == SECOND_PRINCIPAL_STRESS) return "SECOND_PRINCIPAL_STRESS";
  else if (i == THIRD_PRINCIPAL_STRESS) return "THIRD_PRINCIPAL_STRESS";
  else if (i == GL_EFFECTIVE_STRAIN_RATE) return "GL_EFFECTIVE_STRAIN_RATE";
  else if (i == DISP_JUMP_X) return "DISP_JUMP_X";
  else if (i == DISP_JUMP_Y) return "DISP_JUMP_Y";
  else if (i == DISP_JUMP_Z) return "DISP_JUMP_Z";
  else if (i == STRESS_TRIAXIALITY) return "STRESS_TRIAXIALITY";
  else if (i == ACTIVE_DAMAGING_ZONE) return "ACTIVE_DAMAGING_ZONE";
  else if (i == FIELD_CAPACITY) return "FIELD_CAPACITY";
  else if (i == MECHANICAL_SOURCE) return "MECHANICAL_SOURCE";
  else if (i == FIELD_SOURCE) return "FIELD_SOURCE";
  else if (i == INCOMPATIBLE_STRAIN_X) return "INCOMPATIBLE_STRAIN_X";
  else if (i == INCOMPATIBLE_STRAIN_Y) return "INCOMPATIBLE_STRAIN_Y";
  else if (i == INCOMPATIBLE_STRAIN_Z) return "INCOMPATIBLE_STRAIN_Z";
  else if (i == COHESIVE_JUMP_X) return "COHESIVE_JUMP_X";
  else if (i == COHESIVE_JUMP_Y) return "COHESIVE_JUMP_Y";
  else if (i == COHESIVE_JUMP_Z) return "COHESIVE_JUMP_Z";
  else if (i == DAMAGE_IS_BLOCKED) return "DAMAGE_IS_BLOCKED";
  else if (i == DEFO_ENERGY) return "DEFO_ENERGY";
  else if (i == PLASTIC_ENERGY) return "PLASTIC_ENERGY";
  else if (i == DAMAGE_ENERGY) return "DAMAGE_ENERGY";
  else if (i == IRREVERSIBLE_ENERGY) return "IRREVERSIBLE_ENERGY";
  else if (i == MTX_STRAIN_XX) return "MTX_STRAIN_XX";
  else if (i == MTX_STRAIN_YY) return "MTX_STRAIN_YY";
  else if (i == MTX_STRAIN_ZZ) return "MTX_STRAIN_ZZ";
  else if (i == MTX_STRAIN_XY) return "MTX_STRAIN_XY";
  else if (i == MTX_STRAIN_YZ) return "MTX_STRAIN_YZ";
  else if (i == MTX_STRAIN_XZ) return "MTX_STRAIN_XZ";
  else if (i == INC_STRAIN_XX) return "INC_STRAIN_XX";
  else if (i == INC_STRAIN_YY) return "INC_STRAIN_YY";
  else if (i == INC_STRAIN_ZZ) return "INC_STRAIN_ZZ";
  else if (i == INC_STRAIN_XY) return "INC_STRAIN_XY";
  else if (i == INC_STRAIN_YZ) return "INC_STRAIN_YZ";
  else if (i == INC_STRAIN_XZ) return "INC_STRAIN_XZ";
  else if (i == EXTRAFIELD_1) return "EXTRAFIELD_1";
  else if (i == EXTRAFIELD_2) return "EXTRAFIELD_2";
  else if (i == EXTRAFIELD_3) return "EXTRAFIELD_3";
  else if (i == EXTRAFIELD_4) return "EXTRAFIELD_4";
  else if (i == EXTRAFIELD_5) return "EXTRAFIELD_5";
  else if (i == EXTRAFIELD_6) return "EXTRAFIELD_6";
  else if (i == EXTRAFIELD_7) return "EXTRAFIELD_7";
  else if (i == EXTRAFIELD_8) return "EXTRAFIELD_8";
  else if (i == EXTRAFIELD_9) return "EXTRAFIELD_9";
  else if (i == EXTRAFIELD_NORM) return "EXTRAFIELD_NORM";
  else if (i == DELETED) return "DELETED";
  else if (i == LOST_ELLIPTICITY) return "LOST_ELLIPTICITY";
  else if (i == LOCAL_0) return "LOCAL_0";
  else if (i == LOCAL_1) return "LOCAL_1";
  else if (i == LOCAL_2) return "LOCAL_2";
  else if (i == NONLOCAL_0) return "NONLOCAL_0";
  else if (i == NONLOCAL_1) return "NONLOCAL_1";
  else if (i == NONLOCAL_2) return "NONLOCAL_2";
  else if (i == FAILED) return "FAILED";
  else if (i == GL_XX) return "GL_XX";
  else if (i == GL_XY) return "GL_XY";
  else if (i == GL_XZ) return "GL_XZ";
  else if (i == GL_YY) return "GL_YY";
  else if (i == GL_YZ) return "GL_YZ";
  else if (i == GL_ZZ) return "GL_ZZ";
  else if (i == COALESCENCE) return "COALESCENCE";
  else if (i == COALESCENCE_SHEAR) return "COALESCENCE_SHEAR";
  else if (i == COALESCENCE_NECKING) return "COALESCENCE_NECKING";
  else if (i == COALESCENCE_CRITERION) return "COALESCENCE_CRITERION";
  else if (i == LIGAMENT_RATIO) return "LIGAMENT_RATIO";
  else if (i == POROSITY_COALESCENCE_ONSET) return "POROSITY_COALESCENCE_ONSET";
  else if (i == CL_XX) return "CL_XX";
  else if (i == CL_YY) return "CL_YY";
  else if (i == CL_ZZ) return "CL_ZZ";
  else if (i == VOLUMETRIC_PLASTIC_STRAIN) return "VOLUMETRIC_PLASTIC_STRAIN";
  else if (i == LODE_PARAMETER) return "LODE_PARAMETER";
  else if (i == DEVIATORIC_PLASTIC_STRAIN) return "DEVIATORIC_PLASTIC_STRAIN";
  else if (i == ASPECT_RATIO) return "ASPECT_RATIO";
  else if (i == SHAPE_FACTOR) return "SHAPE_FACTOR";
  else if (i == LIGAMENT_RATIO_COALESCENCE_ONSET) return "LIGAMENT_RATIO_COALESCENCE_ONSET";
  else if (i == ASPECT_RATIO_COALESCENCE_ONSET) return "ASPECT_RATIO_COALESCENCE_ONSET";
  else if (i == SHAPE_FACTOR_COALESCENCE_ONSET) return "SHAPE_FACTOR_COALESCENCE_ONSET";
  else if (i == INC_VOLUME_RATIO) return "INC_VOLUME_RATIO";
  else if (i == INC_ASPECT_RATIO_1) return "INC_ASPECT_RATIO_1";
  else if (i == INC_ASPECT_RATIO_2) return "INC_ASPECT_RATIO_2";
  else if (i == INC_R_XX) return "INC_R_XX";
  else if (i == INC_R_XY) return "INC_R_XY";
  else if (i == INC_R_XZ) return "INC_R_XZ";
  else if (i == INC_R_YX) return "INC_R_YX";
  else if (i == INC_R_YY) return "INC_R_YY";
  else if (i == INC_R_YZ) return "INC_R_YZ";
  else if (i == INC_R_ZX) return "INC_R_ZX";
  else if (i == INC_R_ZY) return "INC_R_ZY";
  else if (i == INC_R_ZZ) return "INC_R_ZZ";
    //phenomenologicalSMP
    else if (i == FTH_XX) return "FTH_XX";
    else if (i == FTH_YY) return "FTH_YY";
    else if (i == FTH_ZZ) return "FTH_ZZ";
    else if (i == FTH_XY) return "FTH_XY";
    else if (i == FTH_YZ) return "FTH_YZ";
    else if (i == FTH_ZX) return "FTH_ZX";

    else if (i == FF_XX) return "FF_XX";
    else if (i == FF_YY) return "FF_YY";
    else if (i == FF_ZZ) return "FF_ZZ";
    else if (i == FF_XY) return "FF_XY";
    else if (i == FF_YZ) return "FF_YZ";
    else if (i == FF_ZX) return "FF_ZX";

    else if (i == FPG_XX) return "FPG_XX";
    else if (i == FPG_YY) return "FPG_YY";
    else if (i == FPG_ZZ) return "FPG_ZZ";
    else if (i == FPG_XY) return "FPG_XY";
    else if (i == FPG_YZ) return "FPG_YZ";
    else if (i == FPG_ZX) return "FPG_ZX";

    else if (i == FG_XX) return "FG_XX";
    else if (i == FG_YY) return "FG_YY";
    else if (i == FG_ZZ) return "FG_ZZ";
    else if (i == FG_XY) return "FG_XY";
    else if (i == FG_YZ) return "FG_YZ";
    else if (i == FG_ZX) return "FG_ZX";

    else if (i == FP_XX) return "FP_XX";
    else if (i == FP_YY) return "FP_YY";
    else if (i == FP_ZZ) return "FP_ZZ";
    else if (i == FP_XY) return "FP_XY";
    else if (i == FP_YX) return "FP_YX";
    else if (i == FP_YZ) return "FP_YZ";
    else if (i == FP_ZY) return "FP_ZY";
    else if (i == FP_ZX) return "FP_ZX";
    else if (i == FP_XZ) return "FP_XZ";

    else if (i == FR_XX) return "FR_XX";
    else if (i == FR_YY) return "FR_YY";
    else if (i == FR_ZZ) return "FR_ZZ";
    else if (i == FR_XY) return "FR_XY";
    else if (i == FR_YZ) return "FR_YZ";
    else if (i == FR_ZX) return "FR_ZX";

    else if (i == ZG) return "ZG";
    else if (i == TIG) return "TIG";
    else if (i == TIR) return "TIR";
    else if (i == TT) return "TT";
    //phenomenologicalSMP

  else{
    Msg::Warning("This IP field %d is not defined in IPField::ToString(%d)",i,i);
    return "UNDEFINED";
  }
};

void IPField::compute1state(IPStateBase::whichState ws, bool stiff){
	std::vector<partDomain*>* domainVector = _solver->getDomainVector();
	unknownField* ufield = _solver->getUnknownField();
  for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
    partDomain *dom = *itdom;
    dom->computeIPVariable(_AIPS,ufield,ws,stiff);
  }
}

void IPField::checkInternalState(){
  //Msg::Info("internal state checking ...");
  // clear all broken solver
  _solverBrokenIPs.clear();
  std::vector<partDomain*>* domainVector = _solver->getDomainVector();
  for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
    partDomain *dom = *itdom;
    dom->checkInternalState(this);
  };

  #if defined(HAVE_MPI)
  if ((_solver->getNumRanks() > 1) and _withMultiscale){
    // all root and otherRanks of solvers
    std::set<int> allOtherRanks;
    _solver->getAllOtherRanks(allOtherRanks);

    std::set<int> allRootRanks;
    _solver->getAllRootRanks(allRootRanks);

    // at root rank, the solver is solved in other rank
    // the solver broken flag must be synchronised
    if (allOtherRanks.find(Msg::GetCommRank()) != allOtherRanks.end()){
      int rootRank;
      _solver->getRootRank(Msg::GetCommRank(),rootRank);
      //
      // send numSize to root ranks
      int bufferSize = _solverBrokenIPs.size();
      int tag = numericalMaterialBase::createTypeWithTwoInts(Msg::GetCommRank(),0);
      MPI_Send(&bufferSize,1,MPI_INT,rootRank,tag,MPI_COMM_WORLD);
      if (bufferSize > 0){
        //
        std::vector<int> buffer(_solverBrokenIPs.begin(),_solverBrokenIPs.end()); // send to rootRankd
        tag = numericalMaterialBase::createTypeWithTwoInts(Msg::GetCommRank(),1);
        MPI_Send(&buffer[0],bufferSize,MPI_INT,rootRank,tag,MPI_COMM_WORLD);
      }
    }
    else if ((allRootRanks.find(Msg::GetCommRank()) != allRootRanks.end()) and allOtherRanks.size() > 0){
      std::set<int> otherRanks;
      _solver->getOtherRanks(Msg::GetCommRank(),otherRanks);
      for (std::set<int>::const_iterator itR = otherRanks.begin(); itR != otherRanks.end(); itR ++){
        int tag = numericalMaterialBase::createTypeWithTwoInts(*itR,0);
        int bufferSize= 0;
        MPI_Status status;
        MPI_Recv(&bufferSize,1,MPI_INT,*itR,tag,MPI_COMM_WORLD,&status);
        if (bufferSize > 0){
          std::vector<int> buffer(bufferSize);
          tag = numericalMaterialBase::createTypeWithTwoInts(*itR,1);
          MPI_Recv(&buffer[0],bufferSize,MPI_INT,*itR,tag,MPI_COMM_WORLD,&status);
          // add data at roots
          _solverBrokenIPs.insert(buffer.begin(),buffer.end());
          // at root rank, now
          for (int i=0; i< bufferSize; i++){
            int elnum,gpnum;
            numericalMaterialBase::getTwoIntsFromType(buffer[i],elnum,gpnum);
            AllIPState::ipstateContainer::iterator it = _AIPS->getAIPSContainer()->find(elnum);
            if (it != _AIPS->getAIPSContainer()->end()){
              AllIPState::ipstateElementContainer& ips = it->second;
              IPVariable* ipv = ips[gpnum]->getState(IPStateBase::current);
              IPVariableMechanics* ipvMecha = static_cast<IPVariableMechanics*>(ipv);
              ipvMecha->brokenSolver(true);
              #ifdef _DEBUG
                printf("rank %d solver broken from other rank at  ele %d gp %d \n",Msg::GetCommRank(),elnum,gpnum);
              #endif // _DEBUG
            }
          }
        }
      }
    }
    Msg::Barrier();
  };
  #endif // HAVE_MPI
  //Msg::Info("done internal state checking");
};

void IPField::checkFailure(){
  if (!_withCohesiveFailure) return; // do nothing without cohesive law

  //Msg::Info("failure checking ...");
  // get data in order to send to other procs
  // only new block and broken ips are filled in the group
  _blockedDissipationIPs.clear();
  _brokenIPs.clear();

  //
  _nonBrokenIPs.clear();
  _nonBlockedDissipationIPs.clear();

  _newlyBlockedDissipationElements.clear();
  _newlyBrokenElements.clear();

  _numOfNewlyBrokenElements = 0;
  _totalNumOfNewlyBrokenElements = 0.;
  //Msg::Info("checking failure all IP"); //too many output in explicit

  // Check cohesive insertion at current time step on all domains
  std::vector<partDomain*>* domainVector = _solver->getDomainVector();
    // Loop on domains
  for (int idom=0; idom < domainVector->size(); idom++)
  {
    partDomain* dom = (*domainVector)[idom];
    dom->checkFailure(this);
  }

  _totalNumOfNewlyBrokenElements = _numOfNewlyBrokenElements;

  #if defined(HAVE_MPI)
  std::set<int> allRootRanks;
  _solver->getAllRootRanks(allRootRanks);
  if (allRootRanks.size() > 0){
    _totalNumOfNewlyBrokenElements = 0;
    MPI_Allreduce((void*)&_numOfNewlyBrokenElements, (void*)&_totalNumOfNewlyBrokenElements, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD);
  }
  #endif // HAVE_MPI

  //Msg::Info("done failure checking ...");
};

void IPField::flushFailureState(){
  _failureStateIsFlushed = true;
  if (!_withCohesiveFailure) return; // do nothing without cohesive law
  // flush data at root ranks
  // with modified _brokenIPs, _blockedDissipationIPs
  #if defined(HAVE_MPI)
  std::set<int> allOtherRanks;
  _solver->getAllOtherRanks(allOtherRanks);
  if (allOtherRanks.find(Msg::GetCommRank()) == allOtherRanks.end())
  #endif // HAVE_MPI
  {
    // failure IP
    for (std::set<int>::iterator itn = _nonBrokenIPs.begin(); itn != _nonBrokenIPs.end(); itn++){
      _brokenIPs.erase(*itn);
      int elnum,gpnum;
      numericalMaterialBase::getTwoIntsFromType(*itn,elnum,gpnum);
      AllIPState::ipstateContainer::iterator its = _AIPS->getAIPSContainer()->find(elnum);
      if (its != _AIPS->getAIPSContainer()->end()){
        AllIPState::ipstateElementContainer& vips = its->second;
        IPVariable* ipv = vips[gpnum]->getState(IPStateBase::current);
        IPVariable2ForFractureBase* ipvFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipv);
        if (ipvFrac != NULL){
          ipvFrac->nobroken();
          if (Msg::GetCommSize() > 1)
            printf("rank %d IP failure state is modified from broken to nobroken ele %d gp %d \n",Msg::GetCommRank(),elnum,gpnum);
          else
            printf("IP failure state is modified from broken to nobroken ele %d gp %d \n",elnum,gpnum);
        }
      }
      else{
        Msg::Error("IPstate of element %d, GP %d can not be found",elnum,gpnum);
      }
    }

    // block IP
    for (std::set<int>::iterator itn = _nonBlockedDissipationIPs.begin(); itn != _nonBlockedDissipationIPs.end(); itn++){
      _blockedDissipationIPs.erase(*itn);
      int elnum,gpnum;
      numericalMaterialBase::getTwoIntsFromType(*itn,elnum,gpnum);
      AllIPState::ipstateContainer::iterator its = _AIPS->getAIPSContainer()->find(elnum);
      if (its != _AIPS->getAIPSContainer()->end()){
        AllIPState::ipstateElementContainer& vips = its->second;
        IPVariable* ipv = vips[gpnum]->getState(IPStateBase::current);
        IPVariableMechanics* ipvMecha = static_cast<IPVariableMechanics*>(ipv);
        ipvMecha->blockDissipation(false);
        if (Msg::GetCommSize() > 1)
          printf("rank %d  IP dissipation blocked state ele %d gp %d is unblocked \n",Msg::GetCommRank(),elnum,gpnum);
        else
          printf("IP dissipation blocked state ele %d gp %d is unblocked \n",elnum,gpnum);
      }
      else{
        Msg::Error("IPstate of element %d, GP %d can not be found",elnum,gpnum);
      }
    }
  }
  // communication with otherRanks
  // synchronization between rootRanks and otherRanks
  #if defined(HAVE_MPI)
  if (_solver->getNumRanks() > 1){

    std::set<int> allOtherRanks;
    _solver->getAllOtherRanks(allOtherRanks);

    std::set<int> allRootRanks;
    _solver->getAllRootRanks(allRootRanks);
    // send from rootRank to other rank
    if ((allRootRanks.find(Msg::GetCommRank()) != allRootRanks.end()) and (allOtherRanks.size() > 0)){
      std::set<int> otherRanks;
      _solver->getOtherRanks(Msg::GetCommRank(),otherRanks);
      std::vector<int> bufferSize(2);
      bufferSize[0] = _brokenIPs.size();
      bufferSize[1] = _blockedDissipationIPs.size();

      int allBufferSize = bufferSize[0]+bufferSize[1];
      std::vector<int> buffer(_brokenIPs.begin(),_brokenIPs.end());
      buffer.insert(buffer.end(),_blockedDissipationIPs.begin(),_blockedDissipationIPs.end());

      for (std::set<int>::const_iterator itR = otherRanks.begin(); itR != otherRanks.end(); itR ++){
        int tag = numericalMaterialBase::createTypeWithTwoInts(Msg::GetCommRank(),3);
        MPI_Send(&bufferSize[0],2,MPI_INT,*itR,tag,MPI_COMM_WORLD);
        if (allBufferSize >0){
          tag = numericalMaterialBase::createTypeWithTwoInts(Msg::GetCommRank(),4);
          MPI_Send(&buffer[0],allBufferSize,MPI_INT,*itR,tag,MPI_COMM_WORLD);
        }
      }
    }
    else if (allOtherRanks.find(Msg::GetCommRank()) != allOtherRanks.end()){
      int rootRank;
      _solver->getRootRank(Msg::GetCommRank(),rootRank);
      MPI_Status status;
      std::vector<int> bufferSize(2);
      int tag = numericalMaterialBase::createTypeWithTwoInts(rootRank,3);
      MPI_Recv(&bufferSize[0],2,MPI_INT,rootRank,tag,MPI_COMM_WORLD,&status);
      int allBufferSize = bufferSize[0]+bufferSize[1];
      if (allBufferSize > 0){
        std::vector<int> buffer(allBufferSize);
        tag = numericalMaterialBase::createTypeWithTwoInts(rootRank,4);
        MPI_Recv(&buffer[0],allBufferSize,MPI_INT,rootRank,tag,MPI_COMM_WORLD,&status);

        for (int i=0; i< bufferSize[0]; i++){
          _brokenIPs.insert(buffer[i]);
          AllIPState::ipstateContainer::iterator it = _AIPS->getAIPSContainer()->find(buffer[i]);
          if (it != _AIPS->getAIPSContainer()->end()){
            AllIPState::ipstateElementContainer& ips = it->second;
            IPVariable* ipv = ips[0]->getState(IPStateBase::current);
            IPVariable2ForFractureBase* ipvFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipv);
            if (ipvFrac != NULL){
              ipvFrac->broken();
              int elnum,gpnum;
              numericalMaterialBase::getTwoIntsFromType(buffer[i],elnum,gpnum);
              printf("rank %d broken IP ele %d gp %d  from root ranks \n",Msg::GetCommRank(),elnum,gpnum);
            }
          }
        }
        for (int i=bufferSize[0]; i< allBufferSize; i++){
          _blockedDissipationIPs.insert(buffer[i]);
          AllIPState::ipstateContainer::iterator it = _AIPS->getAIPSContainer()->find(buffer[i]);
          if (it != _AIPS->getAIPSContainer()->end()){
            AllIPState::ipstateElementContainer& ips = it->second;
            IPVariable* ipv = ips[0]->getState(IPStateBase::current);
            IPVariableMechanics* ipvMecha = static_cast<IPVariableMechanics*>(ipv);
            ipvMecha->blockDissipation(true);
            int elnum,gpnum;
            numericalMaterialBase::getTwoIntsFromType(buffer[i],elnum,gpnum);
            printf("rank %d blocked IP ele %d gp %d from root ranks\n",Msg::GetCommRank(),elnum,gpnum);
          }
        }
      }
    }
  }
  #endif // HAVE_MPI
};

void IPField::checkAll(){
  // check state
  this->checkInternalState();
  this->checkFailure();
  //
  _failureAndInternalAreChecked = true;
};

void IPField::nextStep(const double time){
  if (!_failureAndInternalAreChecked){
    this->checkAll();
  }
  _failureAndInternalAreChecked = false; // reset

  if (!_failureStateIsFlushed){
    this->flushFailureState();
  }
  _failureStateIsFlushed = false;

  // save tempory data by transfering buffer
    // newly blocked elements
  _blockedDissipationElements.insert(_newlyBlockedDissipationElements.cbegin(),_newlyBlockedDissipationElements.cend());
    // newly broken elements
  _brokenElements.insert(_newlyBrokenElements.cbegin(),_newlyBrokenElements.cend());


  _blockedDissipationIPs.clear();
  _brokenIPs.clear();
  //
  _nonBrokenIPs.clear();
  _nonBlockedDissipationIPs.clear();

  _newlyBlockedDissipationElements.clear();
  _newlyBrokenElements.clear();

  _solverBrokenIPs.clear();

  _numOfNewlyBrokenElements = 0;
  _totalNumOfNewlyBrokenElements = 0.;

  _AIPS->nextStep();
};

void IPField::copy(IPStateBase::whichState source, IPStateBase::whichState dest){
  // reset data
  _failureAndInternalAreChecked = false; // reset
  _failureStateIsFlushed = false;

  _blockedDissipationIPs.clear();
  _brokenIPs.clear();
  //
  _nonBrokenIPs.clear();
  _nonBlockedDissipationIPs.clear();

  _newlyBlockedDissipationElements.clear();
  _newlyBrokenElements.clear();

  _solverBrokenIPs.clear();

  _numOfNewlyBrokenElements = 0;
  _totalNumOfNewlyBrokenElements = 0.;

  _AIPS->copy(source,dest);
};

void IPField::checkActiveDissipation(){
	// check active damage state
	// should be call after
	_numOfActiveDissipationIPs = 0;
	if (_withDissipation){
    for (AllIPState::ipstateContainer::const_iterator it = _AIPS->begin(); it!= _AIPS->end(); it++){
      const std::vector<IPStateBase*> *vips = &((*it).second);
      for (int i = 0; i< vips->size(); i++){
        const IPVariableMechanics* ipvcur = dynamic_cast<const IPVariableMechanics*>((*vips)[i]->getState(IPStateBase::current));
        if (ipvcur != NULL){
          if (ipvcur->dissipationIsActive()){
            _numOfActiveDissipationIPs++;
          }
        }
      }
    }

    #if defined(HAVE_MPI)
    if (_solver->getNumRanks() > 1){
      int totalNumber = 0;
      MPI_Allreduce(&_numOfActiveDissipationIPs,&totalNumber,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
      _numOfActiveDissipationIPs = totalNumber;
    }
    #endif //HAVE_MPI

    if (_numOfActiveDissipationIPs > 0){
      _numOfActiveDissipationIPsReached = _numOfActiveDissipationIPs;
      this->copy(IPStateBase::current,IPStateBase::activeDissipation);
    }
  }
};

void IPField::initialBroken(MElement *iele, materialLaw* mlaw ){
 #ifdef _DEBUG
  Msg::Error("Interface element %d is broken at initialization on rank %d",iele->getNum(),Msg::GetCommRank());
 #else
  Msg::Info("Interface element %d is broken at initialization",iele->getNum());
 #endif // _DEBUG
  materialLaw2LawsInitializer * mflaw = dynamic_cast<materialLaw2LawsInitializer*>(mlaw);
  // get ipstate
  AllIPState::ipstateElementContainer *vips;
  IPStateBase *ips;
  vips = _AIPS->getIPstate(iele->getNum());
  for(int i=0;i<vips->size();i++){
    ips = (*vips)[i];
    mflaw->initialBroken(ips);
  }
}

void IPField::initialBroken(GModel* pModel, std::vector<int> &vnumphys){
	std::vector<partDomain*>* domainVector = _solver->getDomainVector();
  std::vector<MVertex*> vv;
  for(int i=0;i<vnumphys.size();i++){
    // get the vertex associated to the physical entities LINES ONLY !!
    pModel->getMeshVerticesForPhysicalGroup(1,vnumphys[i],vv);
    // find the InterfaceElement associated to these vertex (identify interior node as degree 2 min)
    for(std::vector<partDomain*>::iterator itfield = domainVector->begin(); itfield != domainVector->end(); ++itfield){
      if((*itfield)->IsInterfaceTerms())
      {
        dgPartDomain *dgdom = static_cast<dgPartDomain*>(*itfield);
        for(groupOfElements::elementContainer::const_iterator it = dgdom->gi->begin(); it!=dgdom->gi->end(); ++it){
          for(int k=0;k<vv.size();k++){
            if(vv[k] == (*it)->getVertex(2) )
            {
              this->initialBroken(*it, dgdom->getMaterialLaw());
            }
          }
        }
      }
    }
    vv.clear();
  }
}

double IPField::getIPValueOnPhysical(const int dim, const int physical, const int ipVal) const{
  for (int i=0; i < viparch.size(); i++){
    if ((viparch[i].numphys == physical and viparch[i].dim == dim) and ipVal == viparch[i].comp){
      return viparch[i].value;
    }
  }
  Msg::Error("IPField::getIPValueOnPhysical does not exist in physical %d dim %d",physical,dim);
};

const std::vector<partDomain*>& IPField::getDomainVector() const {return *_solver->getDomainVector();};

void IPField::resetArchiving()
{
  elementsField::resetArchiving();
  _lastSaveStep = 0;
  for(std::vector<ip2archive>::iterator it=viparch.begin(); it!=viparch.end(); ++it){
    ip2archive &ipa = *it;
    if (ipa.fp != NULL) fclose(ipa.fp);
    ipa.openFile();
  }

}
void IPField::archive(const double time, const int step, const bool forceView){
  // msh view
  this->buildAllView(_solver,time,step, forceView);

  // txt archive
  if (step > _lastSaveStep)
  {
    if (step%_numStepBetweenTwoSaves == 0 or forceView )
    {
      _lastSaveStep = step;
      for(std::vector<ip2archive>::iterator it=viparch.begin(); it!=viparch.end(); ++it){
        ip2archive &ipa = *it;
        // get ip value
        if( ipa.ele.size() == 1)
        {
          ipa.value = this->getIPcomp(ipa.domain[0],ipa.ele[0],IPStateBase::current,ipa.comp,
                                        ipa.evalue,ipa.numgauss);
          fprintf(ipa.fp,"%e;%e\n",time,ipa.value);
          fflush (ipa.fp);
        }
        else
        {
          double totalVolume = 0.;
          double totalValue = 0;
          if(ipa.evalue == nlsField::min) totalValue = 1.e50;
          if(ipa.evalue == nlsField::max) totalValue = -1.e50;
          std::vector<const partDomain *>::const_iterator itd = ipa.domain.begin();
          for(std::vector<MElement *>::const_iterator ite = ipa.ele.begin();
              ite !=  ipa.ele.end(); ite++, itd++)
          {
            double vol = 0.;
            double val = this->getIPcompAndVolume(*itd,*ite, IPStateBase::current, ipa.comp,
                                      ipa.evalue,vol);
            totalVolume += vol;
            if(ipa.evalue == nlsField::crude)
            {
              Msg::Error("Cannot archive on a non nodal entity crude values");
            }
            else
            {
              switch(ipa.evalue){
                case nlsField::max :
                 if(val>totalValue) totalValue=val;
                 break;
                case nlsField::min :
                 if(val<totalValue) totalValue=val;
                 break;
                case nlsField::mean :
                 totalValue+=val*vol;
                 break;
              }
            }
          }
          if(ipa.evalue==nlsField::mean && totalVolume!=0.) totalValue/=totalVolume;
          ipa.value = totalValue;
          fprintf(ipa.fp,"%e;%e\n",time,totalValue);
          fflush (ipa.fp);
        }
      }
    }
  }
};

double IPField::computeBulkDeformationEnergy(MElement *ele, const partDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }

  for(int i=0;i<npts;i++){
    IPStateBase* ips = (*vips)[i];
   #ifdef DEBUG_
    IPVariableMechanics *ipv = dynamic_cast<IPVariableMechanics*>(ips->getState(ws));
    if(ipv == NULL){
      Msg::Error("Compute defo energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws));
   #endif // DEBUG_
    double enerpt = ipv->defoEnergy();
    // gauss point weight
    double weight = GP[i].weight;
    ener += weight*vdetJ[i]*enerpt;
  }
  return ener;
}

double IPField::computeInterfaceDeformationEnergy(MElement *ele, const dgPartDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getInterfaceGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }

  for(int i=0;i<npts;i++){
    IPStateBase* ipsm = (*vips)[i];
    IPStateBase* ipsp = (*vips)[i+npts];

   #ifdef DEBUG_
    IPVariableMechanics *ipvm = dynamic_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = dynamic_cast<IPVariableMechanics*>(ipsp->getState(ws));
    if(ipvm == NULL){
      Msg::Error("Compute defo energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipvm = static_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = static_cast<IPVariableMechanics*>(ipsp->getState(ws));
   #endif // DEBUG_

		IPVariable2ForFractureBase* ipvmFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipvm);
		if (ipvmFrac != NULL){
			if (ipvmFrac->isbroken()){
				double enerpt = 0.5*(ipvm->defoEnergy()+ipvp->defoEnergy());
				// gauss point weight
				double weight = GP[i].weight;
				ener += weight*vdetJ[i]*enerpt;
			}

		}
  }
  return ener;
}

double IPField::computeDeformationEnergy(const IPStateBase::whichState ws) const{
	const std::vector<partDomain*>* domainVector = _solver->getDomainVector();
	double ener=0.;
	for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
		partDomain *dom = *itdom;
		for(groupOfElements::elementContainer::const_iterator it=dom->g_cbegin(); it!=dom->g_cend(); ++it){
			MElement *ele = *it;
			ener += this->computeBulkDeformationEnergy(ele,dom,ws);
		}
		if (dom->IsInterfaceTerms()){
			dgPartDomain* dgdom = static_cast<dgPartDomain*>(dom);
			for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it){
				MElement *ele = *it;
			 #if defined(HAVE_MPI)
				if(Msg::GetCommSize()>1)
				{
					MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
					if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
					{
						ener += this->computeInterfaceDeformationEnergy(ele,dgdom,ws);
					}
				}
				else
			 #endif // HAVE_MPI
				{
					ener += this->computeInterfaceDeformationEnergy(ele,dgdom,ws);
				}

			}
		}
	}
	return ener;
}

double IPField::computeBulkPlasticEnergy(MElement *ele, const partDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }
  for(int i=0;i<npts;i++){
    IPStateBase* ips = (*vips)[i];
   #ifdef DEBUG_
    IPVariableMechanics *ipv = dynamic_cast<IPVariableMechanics*>(ips->getState(ws));
    if(ipv == NULL){
      Msg::Error("Compute plastic energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws));
   #endif // DEBUG_
    double enerpt = ipv->plasticEnergy();
    // gauss point weight
    double weight = GP[i].weight;
    ener += weight*vdetJ[i]*enerpt;
  }
  return ener;
}

double IPField::computeInterfacePlasticEnergy(MElement *ele, const dgPartDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getInterfaceGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }

  for(int i=0;i<npts;i++){
    IPStateBase* ipsm = (*vips)[i];
    IPStateBase* ipsp = (*vips)[i+npts];
   #ifdef DEBUG_
    IPVariableMechanics *ipvm = dynamic_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = dynamic_cast<IPVariableMechanics*>(ipsp->getState(ws));
    if(ipvm == NULL){
      Msg::Error("Compute defo energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipvm = static_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = static_cast<IPVariableMechanics*>(ipsp->getState(ws));
   #endif // DEBUG_

		IPVariable2ForFractureBase* ipvmFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipvm);
		if (ipvmFrac != NULL){
			if (ipvmFrac->isbroken()){
				double enerpt = 0.5*(ipvm->plasticEnergy()+ipvp->plasticEnergy());
				// gauss point weight
				double weight = GP[i].weight;
				ener += weight*vdetJ[i]*enerpt;
			}

		}
  }
  return ener;
}


double IPField::computePlasticEnergy(const IPStateBase::whichState ws) const{
	const std::vector<partDomain*>* domainVector = _solver->getDomainVector();
	double ener=0.;
	for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
		partDomain *dom = *itdom;
		for(groupOfElements::elementContainer::const_iterator it=dom->g_cbegin(); it!=dom->g_cend(); ++it){
			MElement *ele = *it;
			ener += this->computeBulkPlasticEnergy(ele,dom,ws);
		}
    if (dom->IsInterfaceTerms()){
			dgPartDomain* dgdom = static_cast<dgPartDomain*>(dom);
			for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it){
				MElement *ele = *it;
			 #if defined(HAVE_MPI)
				if(Msg::GetCommSize()>1)
				{
					MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
					if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
					{
						ener += this->computeInterfacePlasticEnergy(ele,dgdom,ws);
					}
				}
				else
			 #endif // HAVE_MPI
				{
					ener += this->computeInterfacePlasticEnergy(ele,dgdom,ws);
				}

			}
		}
	}
	return ener;
}

double IPField::computeBulkDamageEnergy(MElement *ele, const partDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }
  for(int i=0;i<npts;i++){
    IPStateBase* ips = (*vips)[i];
   #ifdef DEBUG_
    IPVariableMechanics *ipv = dynamic_cast<IPVariableMechanics*>(ips->getState(ws));
    if(ipv == NULL){
      Msg::Error("Compute plastic energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws));
   #endif // DEBUG_
    double enerpt = ipv->damageEnergy();
    // gauss point weight
    double weight = GP[i].weight;
    ener += weight*vdetJ[i]*enerpt;
  }
  return ener;
}

double IPField::computeInterfaceDamageEnergy(MElement *ele, const dgPartDomain *dom, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  double jac[3][3];
  int npts = dom->getInterfaceGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }

  for(int i=0;i<npts;i++){
    IPStateBase* ipsm = (*vips)[i];
    IPStateBase* ipsp = (*vips)[i+npts];
   #ifdef DEBUG_
    IPVariableMechanics *ipvm = dynamic_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = dynamic_cast<IPVariableMechanics*>(ipsp->getState(ws));
    if(ipvm == NULL){
      Msg::Error("Compute defo energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipvm = static_cast<IPVariableMechanics*>(ipsm->getState(ws));
    IPVariableMechanics *ipvp = static_cast<IPVariableMechanics*>(ipsp->getState(ws));
   #endif // DEBUG_

		IPVariable2ForFractureBase* ipvmFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipvm);
		if (ipvmFrac != NULL){
			if (ipvmFrac->isbroken()){
				double enerpt = 0.5*(ipvm->damageEnergy()+ipvp->damageEnergy());
				// gauss point weight
				double weight = GP[i].weight;
				ener += weight*vdetJ[i]*enerpt;
			}

		}
  }
  return ener;
}


double IPField::computeDamageEnergy(const IPStateBase::whichState ws) const{
	const std::vector<partDomain*>* domainVector = _solver->getDomainVector();
	double ener=0.;
	for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
		partDomain *dom = *itdom;
		for(groupOfElements::elementContainer::const_iterator it=dom->g_cbegin(); it!=dom->g_cend(); ++it){
			MElement *ele = *it;
			ener += this->computeBulkDamageEnergy(ele,dom,ws);
		}
    if (dom->IsInterfaceTerms()){
			dgPartDomain* dgdom = static_cast<dgPartDomain*>(dom);
			for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it){
				MElement *ele = *it;
			 #if defined(HAVE_MPI)
				if(Msg::GetCommSize()>1)
				{
					MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
					if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
					{
						ener += this->computeInterfaceDamageEnergy(ele,dgdom,ws);
					}
				}
				else
			 #endif // HAVE_MPI
				{
					ener += this->computeInterfaceDamageEnergy(ele,dgdom,ws);
				}

			}
		}
	}
	return ener;
}

double IPField::computeBulkPathFollowingLocalValue(MElement *ele, const partDomain *dom, const IPStateBase::whichState ws) const{
	IntPt *GP;
  double jac[3][3];
  int npts = dom->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }
  for(int i=0;i<npts;i++){
    IPStateBase* ips = (*vips)[i];
   #ifdef DEBUG_
    IPVariableMechanics *ipv = dynamic_cast<IPVariableMechanics*>(ips->getState(ws));
    if(ipv == NULL){
      Msg::Error("Compute plastic energy on an non mechanics gauss' point");
      return 0.;
    }
   #else
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws));
   #endif // DEBUG_
    double enerpt = ipv->irreversibleEnergy();
    // gauss point weight
    double weight = GP[i].weight;
    ener += weight*vdetJ[i]*enerpt;
  }
  return ener;
};

double IPField::computeInterfacePathFollowingLocalValue(MElement *ele, const dgPartDomain *dom, const IPStateBase::whichState ws) const{
	IntPt *GP;
  static double jac[3][3];
  int npts = dom->getInterfaceGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
	double ener =0.;
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }
  for(int i=0;i<npts;i++){ // loop on minus interface only to compute energy (otherwise it would be computed twice)
    IPStateBase* ips = (*vips)[i];
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws));

		IPVariable2ForFractureBase* ipvFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipv);
		if (ipvFrac != NULL){
			// gauss point weight
			if (ipvFrac->isbroken()){
				double enerpt = ipv->irreversibleEnergy();
				double weight = GP[i].weight;
				const double wJ = weight*vdetJ[i];
				ener += weight*vdetJ[i]*enerpt;
			}

		}
  }
  return ener;
};

double IPField::computePathFollowingLocalValue(const IPStateBase::whichState ws) const{
  const std::vector<partDomain*>* domainVector = _solver->getDomainVector();
	double ener=0.;
  if (_solver->withPathFollowing()){
    if (_solver->getPathFollowingLocation() == nonLinearMechSolver::BULK_INTERFACE){
      for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
        partDomain *dom = *itdom;
        for(groupOfElements::elementContainer::const_iterator it=dom->g_cbegin(); it!=dom->g_cend(); ++it){
          MElement *ele = *it;
          ener += this->computeBulkPathFollowingLocalValue(ele,dom,ws);
        }

        // interface energy
        if(dom->IsInterfaceTerms()) // otherwise no fracture
        {
          const dgPartDomain* dgdom = static_cast<const dgPartDomain*>(dom);
          if((dgdom->getMaterialLawMinus()->getType() == materialLaw::fracture) and (dgdom->getMaterialLawPlus()->getType() == materialLaw::fracture))//comment it to get H1 norm in the interface  e.g. LinearThermoMech
          {
            for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it)
            {
              MElement *ele = *it;
             #if defined(HAVE_MPI)
              if(Msg::GetCommSize()>1)
              {
                MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
                if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
                {
                  ener += this->computeInterfacePathFollowingLocalValue(ele,dgdom,ws);
                }
              }
              else
             #endif // HAVE_MPI
              {
                ener += this->computeInterfacePathFollowingLocalValue(ele,dgdom,ws);
              }
            }
          }
        }
      }
    }
    else if (_solver->getPathFollowingLocation() == nonLinearMechSolver::BULK){
      for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
        partDomain *dom = *itdom;
        // interface energy
        if(dom->IsInterfaceTerms()) // otherwise no fracture
        {
          const dgPartDomain* dgdom = static_cast<const dgPartDomain*>(dom);
          if((dgdom->getMaterialLawMinus()->getType() == materialLaw::fracture) and (dgdom->getMaterialLawPlus()->getType() == materialLaw::fracture))//comment it to get H1 norm in the interface  e.g. LinearThermoMech
          {
            for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it)
            {
              MElement *ele = *it;
             #if defined(HAVE_MPI)
              if(Msg::GetCommSize()>1)
              {
                MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
                if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
                {
                  ener += this->computeInterfacePathFollowingLocalValue(ele,dgdom,ws);
                }
              }
              else
             #endif // HAVE_MPI
              {
                ener += this->computeInterfacePathFollowingLocalValue(ele,dgdom,ws);
              }
            }
          }
        }
      }
    }
    else if (_solver->getPathFollowingLocation() == nonLinearMechSolver::INTERFACE){
      for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
        partDomain *dom = *itdom;
        for(groupOfElements::elementContainer::const_iterator it=dom->g_cbegin(); it!=dom->g_cend(); ++it){
          MElement *ele = *it;
          ener += this->computeBulkPathFollowingLocalValue(ele,dom,ws);
        }
      }
    }
    else{
      Msg::Error("path following location %d has not been correctly defined",_solver->getPathFollowingLocation());
    }
	}
	return ener;
};


int IPField::computeFractureEnergy(MElement *ele, const dgPartDomain *dom,double* arrayEnergy, const IPStateBase::whichState ws) const
{
  IntPt *GP;
  static double jac[3][3];
  int npts = dom->getInterfaceGaussIntegrationRule()->getIntPoints(ele,&GP);
  AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
  // Jacobian values;
  std::vector<double> vdetJ(npts);
  const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(dom->getFunctionSpace());
  if(nlsspace!=NULL)
  {
    std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
    nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
    for(int i=0;i<npts;i++)
    {
      vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
    }
  }
  else
  {
    for(int i=0;i<npts;i++)
    {
      const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
      vdetJ[i] = ele->getJacobian(u, v, w, jac);
    }
  }
  int ncomp=0;
  static double tmpArray[10];
  for(int i=0;i<npts;i++){ // loop on minus interface only to compute energy (otherwise it would be computed twice)
    IPStateBase* ips = (*vips)[i];
    IPVariableMechanics *ipv = static_cast<IPVariableMechanics*>(ips->getState(ws)); // The IPField:computeFractureEnergy(double* &) ensures that this is OK
    IPVariable2ForFractureBase* ipvFrac = dynamic_cast<IPVariable2ForFractureBase*>(ipv);
		if (ipvFrac != NULL){
			if(ipvFrac->isbroken())  //comment it to get H1 norm in the interface  e.g. LinearThermoMech
			{
						// gauss point weight
				double weight = GP[i].weight;
				const double wJ = weight*vdetJ[i];

				ncomp = ipv->fractureEnergy(tmpArray);
				for(int j=0;j<ncomp;j++)
					arrayEnergy[j]+= wJ*tmpArray[j];
			}

		}
  }
  return ncomp;
}

int IPField::computeFractureEnergy(double * arrayEnergy,const IPStateBase::whichState ws) const
{
	static double tmpArray[10];
	int maxcomp = 0;
	for(int i=0;i<10;i++){
		arrayEnergy[i]=0.;
		tmpArray[i]=0.;
	}
	const std::vector<partDomain*>* domainVector =  _solver->getDomainVector();
	for(std::vector<partDomain*>::const_iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
		const partDomain *dom = *itdom;
		if(dom->IsInterfaceTerms()) // otherwise no fracture
		{
			const dgPartDomain* dgdom = static_cast<const dgPartDomain*>(dom);
			if((dgdom->getMaterialLawMinus()->getType() == materialLaw::fracture) and (dgdom->getMaterialLawPlus()->getType() == materialLaw::fracture))//comment it to get H1 norm in the interface  e.g. LinearThermoMech
			{
				for(groupOfElements::elementContainer::const_iterator it=dgdom->gi->begin(); it!=dgdom->gi->end(); ++it)
				{
					MElement *ele = *it;
				 #if defined(HAVE_MPI)
					if(Msg::GetCommSize()>1)
					{
						MInterfaceElement *iele = dynamic_cast<MInterfaceElement*>(ele);
						if(iele->getElem(0)->getPartition()==0 or iele->getElem(0)->getPartition() == Msg::GetCommRank()+1) // if - element is ghost not computed to avoid to count twice the contribution
						{
							int ncomp = this->computeFractureEnergy(ele,dgdom,tmpArray,ws);
							for(int i=0;i<ncomp;i++){
								arrayEnergy[i]+=tmpArray[i];
								tmpArray[i]=0.;
							}
							if(ncomp>maxcomp)
								maxcomp = ncomp;
						}
					}
					else
				 #endif // HAVE_MPI
					{
						int ncomp = this->computeFractureEnergy(ele,dgdom,tmpArray,ws);
						for(int i=0;i<ncomp;i++){
							arrayEnergy[i]+=tmpArray[i];
							tmpArray[i]=0.;
						}
						if(ncomp>maxcomp)
							maxcomp = ncomp;
					}
				}
			}
		}
	}
	return maxcomp;
}


IPField::IPField(nonLinearMechSolver* sl, const std::vector<ip2archive> &vaip,
          std::vector<dataBuildView> &dbview_, std::string filename):
          _solver(sl),elementsField(filename,1,dbview_),
          _numOfActiveDissipationIPs(0),_numOfActiveDissipationIPsReached(0),
          _failureAndInternalAreChecked(false),_numOfNewlyBrokenElements(0),
          _totalNumOfNewlyBrokenElements(0), _failureStateIsFlushed(false),
          _lastSaveStep(0)
{
  #if defined(HAVE_MPI)
  if (_solver->getNumRanks() > 1){
    std::vector<int> allFlags(3);
    if (_solver->isMultiscale()) allFlags[0] = 1;
    else allFlags[0] = 0;
    if (_solver->withEnergyDissipation()) allFlags[1] = 1;
    else allFlags[1] = 0;
    if (_solver->withFractureLaw()) allFlags[2] = 1;
    else allFlags[2] = 0;

    std::vector<int> maxAllFlags(3);
    MPI_Allreduce(&allFlags[0],&maxAllFlags[0],3,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
    if (maxAllFlags[0] >0) _withMultiscale = true;
    else _withMultiscale = false;
    if (maxAllFlags[1] >0) _withDissipation = true;
    else _withDissipation = false;
    if (maxAllFlags[2] >0) _withCohesiveFailure = true;
    else _withCohesiveFailure = false;
  }
  else
  #endif // HAVE_MPI
  {
    _withMultiscale = _solver->isMultiscale();
    _withDissipation = _solver->withEnergyDissipation();
    _withCohesiveFailure = _solver->withFractureLaw();
  }

  // Creation of storage for IP data
	std::vector<partDomain*>* domainVector = _solver->getDomainVector();
  _AIPS = new AllIPState(*domainVector);
  // compute the number of element
  long int nelem=0;
  for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
    partDomain *dom = *itdom;
    nelem+= dom->groupOfElementsSize();
  }
  this->setTotElem(nelem);

  // Build the viparch vector (find the nearest ipvariable to each given vertex)
  for(std::vector<ip2archive>::const_iterator ita=vaip.begin(); ita!=vaip.end(); ++ita){
    ip2archive aip(*ita);
    int dim = aip.dim;
    bool flagfind = false;
    bool passDomainSearch = false;
    int nummin = 0;
    if (dim == -1){
      if (aip.plusNum == aip.minusNum){
        // bulk case
        for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom)
        {
          partDomain *dom = *itdom;
          for (groupOfElements::elementContainer::iterator ite = dom->g_cbegin(); ite!= dom->g_cend(); ite++){
            MElement* ele = *ite;
            passDomainSearch = true;
            if (aip.plusNum == ele->getNum()){
              aip.ele.push_back(ele);
              aip.domain.push_back(dom);
              flagfind= true;
              break;
            }
          }
          if (flagfind) break;
        }
        if (!flagfind and passDomainSearch){
          Msg::Error("Element %d is not found",aip.plusNum);
        }
      }
      else{
        // interface case
        for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom)
        {
          partDomain *dom = *itdom;
          dgPartDomain* dgDom = dynamic_cast<dgPartDomain*>(dom);
          if (dgDom != NULL){
             for (groupOfElements::elementContainer::iterator ite = dgDom->gi->begin(); ite!= dgDom->gi->end(); ite++){
              MElement* e = *ite;
              MInterfaceElement* ie = dynamic_cast<MInterfaceElement*>(e);
              int emNum = ie->getElem(0)->getNum();
              int epNum = ie->getElem(1)->getNum();
              passDomainSearch = true;
              if ((aip.plusNum == epNum and aip.minusNum == emNum) or (aip.plusNum == emNum and aip.minusNum == epNum)){
                aip.ele.push_back(e);
                aip.domain.push_back(dom);
                flagfind= true;
                break;
              }
            }
          }
          if (flagfind) break;
        }
        if (!flagfind and passDomainSearch){
          Msg::Warning("Interface Element with positive %d and negative %d is not found",Msg::GetCommRank(),aip.plusNum,aip.minusNum);
        }
      }

      nummin = aip.numgauss;
    }
    else if(dim == 0)
    {
      dgPartDomain *dgdom;
      bool samedim = false;
      for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom)
      {
        partDomain *dom = *itdom;
        if(dom->IsInterfaceTerms())
        { // otherwise the domain doesn't contain interface element
          dgdom = static_cast<dgPartDomain*>(dom);
          for(groupOfElements::elementContainer::iterator it2 = dgdom->gi->begin(); it2 != dgdom->gi->end(); ++it2 )
          {
            MElement *iele = *it2; // two elements on interface
            int numv = iele->getNumVertices();
            for(int j=0;j<numv;j++)
            {
              if(aip._v == iele->getVertex(j))
              {
                aip.ele.push_back(iele);
                aip.domain.push_back(dom);
                flagfind = true;
                break;
              }
            }
            if(flagfind) break;
          }
          if(!flagfind)
          { // the interface element are on boundary
            for(groupOfElements::elementContainer::iterator iti = dgdom->gib->begin(); iti!=dgdom->gib->end(); ++iti){
              MElement *ie = *iti;
              int numv = ie->getNumVertices();
              for(int j=0;j<numv;j++){
                if(aip._v == ie->getVertex(j)){
                  aip.ele.push_back(ie);
                  aip.domain.push_back(dom);
                  flagfind = true;
                  break;
                }
              }
              if(flagfind) break;
            }
          }
        }
        if(!flagfind){ // no interface element found (Can happend on boundary)
          for(groupOfElements::elementContainer::iterator it2 = dom->g_cbegin(); it2 != dom->g_cend(); ++it2 ){
            MElement *ele = *it2;
            int numv = ele->getNumVertices();
            for(int j=0;j<numv;j++){
              if(aip._v == ele->getVertex(j)){
                aip.ele.push_back(ele);
                samedim = true;
                flagfind = true;
                aip.domain.push_back(dom);
                break;
              }
            }
            if(flagfind) break;
          }
        }
        if(flagfind) break;
      }
      if(flagfind){ // If solve on more than one cpu it if possible that the point is not found
        // Now the element where is situated the node is know find the nearest Gauss Point
        IntPt *GP;
        QuadratureBase *gq;
        if(samedim){ //bulk point
          gq = aip.domain[0]->getBulkGaussIntegrationRule();
        }
        else{
          const dgPartDomain *dgfind = static_cast<const dgPartDomain*>(aip.domain[0]);
          gq = dgfind->getInterfaceGaussIntegrationRule();
        }
        int npts = gq->getIntPoints(aip.ele[0],&GP);
        // coordonate in uvw of vertex
        double uvw[3];
        double xyz[3];
        xyz[0] = aip._v->x(); xyz[1] = aip._v->y(); xyz[2] = aip._v->z();
        aip.ele[0]->xyz2uvw(xyz,uvw);
        double distmin = 1.e100; // inf value at itnitialization
        double dist, u,v,w;
        for(int i=0;i<npts;i++){
          u = GP[i].pt[0]; v = GP[i].pt[1]; w = GP[i].pt[2];
          dist = sqrt((u-uvw[0])*(u-uvw[0]) + (v-uvw[1])*(v-uvw[1]) + (w-uvw[2])*(w-uvw[2]));
          if(dist<distmin){
            distmin = dist;
            nummin = i;
          }
        }
      }
    }
    else
    {
      // get the vertex of the node
      groupOfElements g(dim,aip.numphys);
      for(groupOfElements::elementContainer::iterator ite = g.begin(); ite != g.end(); ite++)
      {
        dgPartDomain *dgdom;
        bool samedim = false;
        for(std::vector<partDomain*>::iterator itdom=domainVector->begin(); itdom!=domainVector->end(); ++itdom){
          partDomain *dom = *itdom;
          if(dom->IsInterfaceTerms())
          { // otherwise the domain doesn't contain interface element
            dgdom = static_cast<dgPartDomain*>(dom);
            for(groupOfElements::elementContainer::iterator it2 = dgdom->gi->begin(); it2 != dgdom->gi->end(); ++it2 )
            {
              if(*it2 == *ite)
              {
                aip.ele.push_back(*ite);
                aip.domain.push_back(dom);
                flagfind = true;
              }
            }
            for(groupOfElements::elementContainer::iterator iti = dgdom->gib->begin(); iti!=dgdom->gib->end(); ++iti)
            {
              if(*iti == *ite)
              {
                aip.ele.push_back(*ite);
                aip.domain.push_back(dom);
                flagfind = true;
              }
            }
          }
          for(groupOfElements::elementContainer::iterator it2 = dom->g_cbegin(); it2 != dom->g_cend(); ++it2 )
          {
            if(*it2 == *ite)
            {
              aip.ele.push_back(*ite);
              aip.domain.push_back(dom);
              flagfind = true;
            }
          }
        }
      }
    }
    if(flagfind){ // If solve on more than one cpu it if possible that the point is not found
      // Now the element where is situated the node is know find the nearest Gauss Point
      // Store information
      aip.numgauss = nummin;
      viparch.push_back(ip2archive(aip));

    }
    else
    {
      #if defined(HAVE_MPI)
      if(Msg::GetCommSize() == 1)
      #endif // HAVE_MPI
      {
        Msg::Error("Unable to find an IPVariable where data is supposed to be archived");
      }
    }
  }

  _numStepBetweenTwoSaves = 1;
  for (int i=0; i< viparch.size(); i++)
  {
    viparch[i].openFile();
    if (viparch[i].nstep > _numStepBetweenTwoSaves)
    {
      _numStepBetweenTwoSaves = viparch[i].nstep;
    }
  }
}

IPField::~IPField(){
  delete _AIPS;
}

double IPField::getIPcomp(const partDomain *ef,MElement *ele, const IPStateBase::whichState ws,
                            const int cmp,const nlsField::ElemValue ev,const int num) const{
  if(ev == nlsField::crude){ // value in a particular gauss point
    IPStateBase* ips = (*_AIPS->getIPstate(ele->getNum()))[num];
    IPVariable *ipv = ips->getState(ws);
    return ipv->get(cmp);
  }
  else{ // loop on all IPVariable of an element and return a particular value (max, min, mean)
    double valcmp =0.;
    double valcmpp;
    IntPt *GP;
    int npts = ef->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
    AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
    for(int i=0;i<npts;i++){
      IPStateBase* ips = (*vips)[i];
      IPVariable *ipv = ips->getState(ws);

      valcmpp = ipv->get(cmp);
      if(i==0)
        valcmp = valcmpp;
      else{
        switch(ev){
          case nlsField::max :
            if(valcmpp>valcmp) valcmp=valcmpp;
            break;
          case nlsField::min :
            if(valcmpp<valcmp) valcmp=valcmpp;
            break;
          case nlsField::mean :
            valcmp+=valcmpp;
            break;
        }
      }
    }
    if(ev==nlsField::mean) valcmp/=(double)npts;
    return valcmp;
  }
}
double IPField::getIPcompAndVolume(const partDomain *ef,MElement *ele, const IPStateBase::whichState ws,
                           const int cmp, const nlsField::ElemValue ev, double &vol) const
{
  if(ev == nlsField::crude)
  {
     Msg::Error("Cannot archive on a non nodal endity crude values");
  }
  else
  {
    vol = 0.;
    double valcmp =0.;
    double jac[3][3];
    double valcmpp;
    IntPt *GP;
    int npts = ef->getBulkGaussIntegrationRule()->getIntPoints(ele,&GP);
    AllIPState::ipstateElementContainer *vips = _AIPS->getIPstate(ele->getNum());
    // Jacobian values;
    std::vector<double> vdetJ(npts);
    const nlsFunctionSpaceUVW<double>* nlsspace = dynamic_cast<const nlsFunctionSpaceUVW<double>*>(ef->getFunctionSpace());
    if(nlsspace!=NULL)
    {
      std::vector<std::vector<TensorialTraits<double>::GradType> > vgradsuvw;
      nlsspace->getgradfuvw(ele,npts,GP,vgradsuvw);
      for(int i=0;i<npts;i++)
      {
        vdetJ[i] = ele->getJacobian(vgradsuvw[i],jac);
      }
    }
    else
    {
      for(int i=0;i<npts;i++)
      {
        const double u = GP[i].pt[0]; const double v = GP[i].pt[1]; const double w = GP[i].pt[2];
        vdetJ[i] = ele->getJacobian(u, v, w, jac);
      }
    }
    for(int i=0;i<npts;i++){
      IPStateBase* ips = (*vips)[i];
      IPVariable *ipv = ips->getState(ws);
      double weight = GP[i].weight;
      const double detJ = vdetJ[i];

      valcmpp = ipv->get(cmp);
      vol += detJ*weight;
      if(i==0)
      {
        switch(ev){
          case nlsField::max :
            valcmp = valcmpp;
            break;
          case nlsField::min :
           valcmp = valcmpp;
            break;
          case nlsField::mean :
            valcmp =valcmpp*detJ*weight;
            break;
        }
      }
      else{
        switch(ev){
          case nlsField::max :
            if(valcmpp>valcmp) valcmp=valcmpp;
            break;
          case nlsField::min :
            if(valcmpp<valcmp) valcmp=valcmpp;
            break;
          case nlsField::mean :
            valcmp+=valcmpp*detJ*weight;
            break;
        }
      }
    }
    if(ev==nlsField::mean) valcmp/=vol;
    return valcmp;
  }
}

void IPField::setFactorOnArchivingFiles(const int fact)
{
  for(int i=0;i<viparch.size();i++)
  {
    viparch[i].nstep*=fact;
  }
}


void IPField::blockDissipation(const IPStateBase::whichState ws, const bool fl){
  AllIPState::ipstateContainer& allMap =*(_AIPS->getAIPSContainer());
  for(AllIPState::ipstateContainer::iterator it=allMap.begin(); it!=allMap.end();++it){
    std::vector<IPStateBase*>& vips = ((*it).second);
    for(unsigned int i=0;i<vips.size();i++){
      IPVariable* ipv = vips[i]->getState(ws);
			IPVariableMechanics* ipvMeca = dynamic_cast<IPVariableMechanics*>(ipv);
			if (ipvMeca!=NULL){
				ipvMeca->blockDissipation(fl);
			}
    }
  }
}

void IPField::restart()
{
  elementsField::restart();
  // loop on all ipstates
  _AIPS->restart();

  // since the nextStep() is called before creating restart file
  // only the following parameters needs to save
  restartManager::restart(_lastSaveStep);
  restartManager::restart(_numStepBetweenTwoSaves);
  //
  restartManager::restart(_numOfActiveDissipationIPs);
  restartManager::restart(_numOfActiveDissipationIPsReached);

  restartManager::restart(_brokenElements);         // all interface broken element is stored in order to avoid rechecking
  restartManager::restart(_blockedDissipationElements);     // all blocked element is stored in order to avoid rechecking/reblocking
  return;
}


void IPField::addOneBlockedDissipationElement(MElement* ele){
  _newlyBlockedDissipationElements.insert(ele->getNum());
};


bool IPField::dissipationIsBlockedOnElement(MElement* ele) const{
  return _blockedDissipationElements.find(ele->getNum()) != _blockedDissipationElements.end();
};

void IPField::addOneBrokenElement(MElement* ele){
  MInterfaceElement* ie = dynamic_cast<MInterfaceElement*>(ele);
  if (ie == NULL){
    if (_newlyBrokenElements.find(ele->getNum()) == _newlyBrokenElements.end()){
      _newlyBrokenElements.insert(ele->getNum());
      _numOfNewlyBrokenElements ++;
    }
  }
  else{
    if (_newlyBrokenElements.find(ele->getNum()) == _newlyBrokenElements.end()){
      _newlyBrokenElements.insert(ele->getNum());
      if (ie->getElem(0)->getPartition() == ie->getElem(1)->getPartition()){
        _numOfNewlyBrokenElements ++;
      }
      #if defined(HAVE_MPI)
      else if (Msg::GetCommRank()+1 == std::min(ie->getElem(0)->getPartition(),ie->getElem(1)->getPartition())){
        _numOfNewlyBrokenElements ++;
      }
      #endif //HAVE_MPI
    }
  }
};

bool IPField::elementIsBroken(MElement* ele) const{
  return _brokenElements.find(ele->getNum()) != _brokenElements.end();
};

void IPField::blockDissipationIP(const int ip){
	_blockedDissipationIPs.insert(ip);
};
void IPField::brokenIP(const int ip){
	_brokenIPs.insert(ip);
};

void IPField::solverBroken(const int ip){
  _solverBrokenIPs.insert(ip);
};
