//
// Description: storing class for kinematic hardening law
//
//
// Author:  <V.D. Nguyen>, (C) 2014
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef IPKINEMATICHARDENING_H_
#define IPKINEMATICHARDENING_H_

#include "ipHardening.h"

class IPKinematicHardening{
  protected:
    double R;
    double dR;
    double ddR;
    bool _isSaturated;

  public:
    IPKinematicHardening();
    IPKinematicHardening(const IPKinematicHardening &source);
    virtual IPKinematicHardening &operator=(const IPKinematicHardening &source);
    virtual ~IPKinematicHardening(){}
    virtual void restart();

    virtual IPKinematicHardening * clone() const {return new IPKinematicHardening(*this);};

    virtual bool& getRefToSaturationState() {return _isSaturated;};
    virtual bool isSaturated() const {return _isSaturated;};

    virtual double getR() const {return R;}
    virtual double getDR() const {return dR;}
    virtual double getDDR() const {return ddR;};
    virtual void set(const double &_r, const double &_dr, const double& _ddr)
    {
      R=_r;
      dR=_dr;
      ddR = _ddr;
    }
};


#endif // IPKINEMATICHARDENING_H_
