//
// Description: storing class for  nucleation
//
//
// Author:  <L. Noels>, (C) 2013
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ipNucleation.h"
#include "restartManager.h"
IPNucleation::IPNucleation(): nucleatedfV(0.), DeltafV(0.), DDeltafVDHatP(0.)
{
}

IPNucleation::IPNucleation(const IPNucleation &source):nucleatedfV(source.nucleatedfV), DeltafV(source.DeltafV),DDeltafVDHatP(source.DDeltafVDHatP)
{

}

IPNucleation &IPNucleation::operator=(const IPNucleation &source)
{
  nucleatedfV = source.nucleatedfV;
  DeltafV = source.DeltafV;
  DDeltafVDHatP = source.DDeltafVDHatP;
  return *this;
}


void IPNucleation::restart()
{
  restartManager::restart(nucleatedfV);
  restartManager::restart(DeltafV);
  restartManager::restart(DDeltafVDHatP);
  return;
}

IPLinearNucleationRate::IPLinearNucleationRate(): IPNucleation()
{

}

IPLinearNucleationRate::IPLinearNucleationRate(const IPLinearNucleationRate &source) : IPNucleation(source)
{
}

IPLinearNucleationRate &IPLinearNucleationRate::operator=(const IPNucleation &source)
{
  IPNucleation::operator=(source);
  const IPLinearNucleationRate* src = dynamic_cast<const IPLinearNucleationRate*>(&source);
  if(src != NULL)
  {
  }
  return *this;
}

IPNucleation * IPLinearNucleationRate::clone() const
{

  return new IPLinearNucleationRate(*this);
}

void IPLinearNucleationRate::restart()
{
  IPNucleation::restart();
}

IPExponentialNucleationRate::IPExponentialNucleationRate(): IPNucleation()
{

}

IPExponentialNucleationRate::IPExponentialNucleationRate(const IPExponentialNucleationRate &source) : IPNucleation(source)
{
}

IPExponentialNucleationRate &IPExponentialNucleationRate::operator=(const IPNucleation &source)
{
  IPNucleation::operator=(source);
  const IPExponentialNucleationRate* src = dynamic_cast<const IPExponentialNucleationRate*>(&source);
  if(src != NULL)
  {
  }
  return *this;
}

IPNucleation * IPExponentialNucleationRate::clone() const
{

  return new IPExponentialNucleationRate(*this);
}

void IPExponentialNucleationRate::restart()
{
  IPNucleation::restart();
}
