//
// Description: Provide ip class for nucleation criterion 
//
//
// Author:  <J. Leclerc>, (C) 2019
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "ipNucleationCriterion.h"
#include "restartManager.h"

// IPNucleationCriterion
// -------------------------------------------
IPNucleationCriterion::IPNucleationCriterion()
{
  
};


IPNucleationCriterion::IPNucleationCriterion(const IPNucleationCriterion &source)
{

};

IPNucleationCriterion &IPNucleationCriterion::operator=(const IPNucleationCriterion &source)
{
  return *this;
};

void IPNucleationCriterion::restart()
{
  
};





// IPTrivialNucleationCriterion
// -------------------------------------------
IPTrivialNucleationCriterion::IPTrivialNucleationCriterion() : 
    IPNucleationCriterion()
{
  
};


IPTrivialNucleationCriterion::IPTrivialNucleationCriterion(const IPTrivialNucleationCriterion &source) :
    IPNucleationCriterion(source)
{
  
};


IPTrivialNucleationCriterion &IPTrivialNucleationCriterion::operator=(const IPNucleationCriterion &source)
{
  IPNucleationCriterion::operator=(source);
  return *this;
};

IPNucleationCriterion * IPTrivialNucleationCriterion::clone() const
{
  return new IPTrivialNucleationCriterion(*this);
};




// IPBereminNucleationCriterion
// -------------------------------------------
IPBereminNucleationCriterion::IPBereminNucleationCriterion() : 
    IPNucleationCriterion(),
    _activeNucleation(false)
{
  
};


IPBereminNucleationCriterion::IPBereminNucleationCriterion(const IPBereminNucleationCriterion &source) :
    IPNucleationCriterion(source),
    _activeNucleation(source._activeNucleation)
{
  
};


IPBereminNucleationCriterion &IPBereminNucleationCriterion::operator=(const IPNucleationCriterion &source)
{
  // Copy mother class
  IPNucleationCriterion::operator=(source);
  
  // Copy this class
  const IPBereminNucleationCriterion* src = dynamic_cast<const IPBereminNucleationCriterion*>(&source);
  if(src != NULL)
  {
    _activeNucleation=src->_activeNucleation;
  }
  return *this;
};

IPNucleationCriterion * IPBereminNucleationCriterion::clone() const
{
  return new IPBereminNucleationCriterion(*this);
};


void IPBereminNucleationCriterion::restart()
{
  IPNucleationCriterion::restart();
  restartManager::restart(_activeNucleation);
};


