%{
  #undef HAVE_DLOPEN
  #include "NonLinearSolverConfig.h"
  #include "simpleFunction.h"
  #include "simpleFunctionTime.h"
  #include "timeFunction.h"
  #include "j2IsotropicHardening.h"
  #include "kinematicHardening.h"
  #include "viscosityLaw.h"
  #include "CLengthLaw.h"
  #include "NucleationLaw.h"
  #include "NucleationCriterionLaw.h"
  #include "DamageLaw.h"
  #include "failureCriterion.h"
  #include "mlawHyperelasticFailureCriterion.h"
  #include "materialStrengthLaw.h"
  #include "mlaw.h"
  #include "nonLinearBC.h"
  #include "partDomain.h"
  #include "contactDomain.h"
  #include "defoDefoContactDomain.h"
  #include "frictionLaw.h"
  #include "nonLinearMechSolver.h"
  #include "nlsField.h"
  #include "elementsField.h"
  #include "ipField.h"
  #include "energyField.h"
  #include "groupOfElements.h"
  #include "elementFilterBox.h"
  #include "numericalMaterial.h"
  #include "getTotalVolume.h"
  #include "imperfectionToMesh.h"
  #include "cutMeshByBox.h"
  #include "GmshMessage.h"
  #include "testcheck.h"
  #include "scalarFunction.h"
  #include "geometryRotation.h"
  #include "nonLinearMicroBC.h"
  #include "elasticPotential.h"
  #include "cohesiveElasticPotential.h"
  #include "cohesiveDamageLaw.h"
  #include "endSchemeMonitoring.h"
  #include "CoalescenceLaw.h"
  #include "selectiveUpdate.h"
  #include "voidStateEvolutionLaw.h"
%}

%init%{
  if(Msg::GetCommRank())
    Msg::SetVerbosity(1);
%}

%nodefaultctor J2IsotropicHardening;
%nodefaultctor kinematicHardening;
%nodefaultctor viscosityLaw;
%nodefaultctor RateFailureLaw;
%nodefaultctor CLengthLaw;
%nodefaultctor DamageLaw;
%nodefaultctor FailureCriterionBase;
%nodefaultctor mlawHyperelasticFailureCriterionBase;
%nodefaultctor NucleationLaw;
%nodefaultctor NucleationCriterionLaw;
%nodefaultctor materialLaw;
%nodefaultctor partDomain;
%nodefaultctor dgPartDomain;
%nodefaultctor contactDomain;
%nodefaultctor defoDefoContactDomain;
%nodefaultctor frictionLaw;
%nodefaultctor rigidCylinderContactDomain;
%nodefaultctor rigidConeContactDomain;
%nodefaultctor rigidPlaneContactDomain;
%nodefaultctor nlsField; 
%nodefaultctor elementsField;
%nodefaultctor IPField;
%nodefaultctor energeticField;
%nodefaultctor materialLaw2LawsInitializer;
%nodefaultctor nonLinearBoundaryCondition;
%nodefaultctor numericalMaterialBase;
%nodefaultctor numericalMaterial;
%nodefaultctor getTotalVolume;
%nodefaultctor cutMeshByBox;
%nodefaultctor imperfectionToMesh;
%nodefaultctor imperfectionFunction;
%nodefaultctor imperfectionPart;
%nodefaultctor scalarFunction;
%nodefaultctor GeometryRotation;
%nodefaultctor nonLinearMicroBC;
%nodefaultctor elasticPotential;
%nodefaultctor cohesiveElasticPotential;
%nodefaultctor cohesiveDamageLaw;
%nodefaultctor levelSet;
%nodefaultctor EndSchemeMonitoringBase;
%nodefaultctor CoalescenceLaw;
%nodefaultctor LoadConcentrationFactorBasedCoalescenceLaw;
%nodefaultctor selectiveUpdateBase;
%nodefaultctor voidStateEvolutionLaw;

%include "NonLinearSolverConfig.h"
%include "simpleFunction.h"
%template(simpleFunctionDouble) simpleFunction<double>;
%include "simpleFunctionTime.h"
%template(simpleFunctionTimeDouble) simpleFunctionTime<double>;
%include "timeFunction.h"
%template(simpleFunctionTimeWithConstantDouble) simpleFunctionTimeWithConstant<double>;
%include "j2IsotropicHardening.h"
%include "kinematicHardening.h"
%include "viscosityLaw.h"
%include "CLengthLaw.h"
%include "NucleationLaw.h"
%include "NucleationCriterionLaw.h"
%include "DamageLaw.h"
%include "failureCriterion.h"
%include "mlawHyperelasticFailureCriterion.h"
%include "materialStrengthLaw.h"
%include "mlaw.h"
%include "nonLinearBC.h"
%include "partDomain.h"
%include "contactDomain.h"
%include "defoDefoContactDomain.h"
%include "frictionLaw.h"
%include "nonLinearMechSolver.h"
%include "nlsField.h"
%include "elementsField.h"
%include "ipField.h"
%include "energyField.h"
%include "groupOfElements.h"
%include "elementFilterBox.h"
%include "numericalMaterial.h"
%include "getTotalVolume.h"
%include "cutMeshByBox.h"
%include "imperfectionToMesh.h"
%include "testcheck.h"
%include "scalarFunction.h"
%include "geometryRotation.h"
%include "nonLinearMicroBC.h"
%include "elasticPotential.h"
%include "cohesiveElasticPotential.h"
%include "cohesiveDamageLaw.h"
%include "endSchemeMonitoring.h"
%include "CoalescenceLaw.h"
%include "selectiveUpdate.h"
%include "voidStateEvolutionLaw.h"
