//
// Author:  <Van Dung NGUYEN>, (C) 2017
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef _ELEMENTEROSIONFILTER_H_
#define _ELEMENTEROSIONFILTER_H_
#include "groupOfElements.h"
#include "restartManager.h"

class elementErosionFilter :public elementFilter{
	protected:
		std::set<int> _erosionElements;
	
	public:
		elementErosionFilter(): elementFilter(){}
		virtual ~elementErosionFilter(){}
		
		void addErodedElement(MElement* ele){
			_erosionElements.insert(ele->getNum());
		}
		void restart()
                {
                  restartManager::restart(_erosionElements);
                  //print();
                }
		void print() const{
			if (_erosionElements.size() == 0){
				printf("No element is eroded\n");
			}
			else{
				#if defined(HAVE_MPI)
				if (Msg::GetCommSize() > 1){
					printf("on rank %d, %zd eroded elements: \n",Msg::GetCommRank(),_erosionElements.size());
				}
				else
				#endif //HAVE_MPI
				{
					printf("%zd eroded elements: \n",_erosionElements.size());
				}
				for (std::set<int>::const_iterator it = _erosionElements.begin(); it != _erosionElements.end(); it++){
					printf("%d ",*it);
				}
				printf("\n");
			}
		}
		
		virtual bool operator() (MElement *ele) const {
			if (_erosionElements.size() == 0) return true;
			else if (_erosionElements.find(ele->getNum()) != _erosionElements.end()){
				return false;
			}
			else return true;
		};
};

#endif // _ELEMENTEROSIONFILTER_H_
