//
//
// Description: create pbcElement in PBC problems
//
// Author:  <Van Dung NGUYEN>, (C) 2015
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef PBCELEMENT_H_
#define PBCELEMENT_H_

#include "MElement.h"
#include "dofManager.h"

class partDomain;

class pbcVertex{
  // a class include one vertex _v in element _e inside domain _dom
  protected:
    MVertex* _v;
    MElement* _e;
    partDomain* _dom;

  public:
    pbcVertex(partDomain* dompart, MElement* ele, MVertex* vv);
    virtual ~pbcVertex(){}
    virtual partDomain* getDomain() const {return _dom;};
    virtual MElement* getElement() const {return _e;};
    virtual MVertex* getVertex() const {return _v;};
    virtual void getKeys(std::vector<int>& comp, std::vector<Dof>& keys) const;
};

#endif // PBCELEMENT_H_
