#ifndef OUTPRINTMATRIX_H
#define OUTPRINTMATRIX_H
#include "STensor43.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#endif // OUTPRINTMATRIX_H

class OutPrintMatrix
{
public:

    static void STensor3OnScreen(const STensor3 &X, std::string matrix_name)
    {
        std::cout<<matrix_name<<"\n";
        std::cout<<std::scientific << std::setprecision(14) << X(0,0) << " "<<X(0,1) << " " <<X(0,2) << "\n";
        std::cout << X(1,0) << " "<<X(1,1) << " " << X(1,2)<< "\n";
        std::cout << X(2,0) << " " <<X(2,1) << " " << X(2,2) << "\n";
    };

    static void STensor43OnScreen(const STensor43 &X, std::string matrix_name)
    {
        std::cout<<matrix_name<<"\n";
        std::cout << std::scientific << std::setprecision(14) << X(0,0,0,0) <<"   "<< X(0,0,0,1) <<"   "<<X(0,0,0,2)  << "             "<<X(0,1,0,0) <<"   "<< X(0,1,0,1) <<"   "<<X(0,1,0,2)  << "             "<<X(0,2,0,0) <<"   "<< X(0,2,0,1) <<"   "<<X(0,2,0,2)  <<"\n";
        std::cout << X(0,0,1,0) <<"   "<< X(0,0,1,1) <<"   "<<X(0,0,1,2)  << "             "<<X(0,1,1,0) <<"   "<< X(0,1,1,1) <<"   "<<X(0,1,1,2)  << "             "<<X(0,2,1,0) <<"   "<< X(0,2,1,1) <<"   "<<X(0,2,1,2)  <<"\n";
        std::cout << X(0,0,2,0) <<"   "<< X(0,0,2,1) <<"   "<<X(0,0,2,2)  << "             "<<X(0,1,2,0) <<"   "<< X(0,1,2,1) <<"   "<<X(0,1,2,2)  << "             "<<X(0,2,2,0) <<"   "<< X(0,2,2,1) <<"   "<<X(0,2,2,2)  <<"\n";
        std::cout << X(1,0,0,0) <<"   "<< X(1,0,0,1) <<"   "<<X(1,0,0,2)  << "             "<<X(1,1,0,0) <<"   "<< X(1,1,0,1) <<"   "<<X(1,1,0,2)  << "             "<<X(1,2,0,0) <<"   "<< X(1,2,0,1) <<"   "<<X(1,2,0,2)  <<"\n";
        std::cout << X(1,0,1,0) <<"   "<< X(1,0,1,1) <<"   "<<X(1,0,1,2)  << "             "<<X(1,1,1,0) <<"   "<< X(1,1,1,1) <<"   "<<X(1,1,1,2)  << "             "<<X(1,2,1,0) <<"   "<< X(1,2,1,1) <<"   "<<X(1,2,1,2)  <<"\n";
        std::cout << X(1,0,2,0) <<"   "<< X(1,0,2,1) <<"   "<<X(1,0,2,2)  << "             "<<X(1,1,2,0) <<"   "<< X(1,1,2,1) <<"   "<<X(1,1,2,2)  << "             "<<X(1,2,2,0) <<"   "<< X(1,2,2,1) <<"   "<<X(1,2,2,2)  <<"\n";
        std::cout << X(2,0,0,0) <<"   "<< X(2,0,0,1) <<"   "<<X(2,0,0,2)  << "             "<<X(2,1,0,0) <<"   "<< X(2,1,0,1) <<"   "<<X(2,1,0,2)  << "             "<<X(2,2,0,0) <<"   "<< X(2,2,0,1) <<"   "<<X(2,2,0,2)  <<"\n";
        std::cout << X(2,0,1,0) <<"   "<< X(2,0,1,1) <<"   "<<X(2,0,1,2)  << "             "<<X(2,1,1,0) <<"   "<< X(2,1,1,1) <<"   "<<X(2,1,1,2)  << "             "<<X(2,2,1,0) <<"   "<< X(2,2,1,1) <<"   "<<X(2,2,1,2)  <<"\n";
        std::cout << X(2,0,2,0) <<"   "<< X(2,0,2,1) <<"   "<<X(2,0,2,2)  << "             "<<X(2,1,2,0) <<"   "<< X(2,1,2,1) <<"   "<<X(2,1,2,2)  << "             "<<X(2,2,2,0) <<"   "<< X(2,2,2,1) <<"   "<<X(2,2,2,2)  <<"\n";
    };


    static void Write_STensor3_To_File(const STensor3 &X, std::string matrix_name, std::string file_name, bool append)
    {
        std::ofstream my_file;
        if(append)
        {
            my_file.open(file_name.c_str(),std::ios::app);
        }
        else
        {
            my_file.open(file_name.c_str());
        }
        my_file << matrix_name<<"\n";
        my_file << std::scientific << std::setprecision(14) << X(0,0) << " "<<X(0,1) << " " <<X(0,2) << "\n";
        my_file << X(1,0) << " "<<X(1,1) << " " << X(1,2)<< "\n";
        my_file << X(2,0) << " " <<X(2,1) << " " << X(2,2) << "\n";

        my_file.close();
    };

    static void Write_STensor43_To_File(const STensor43 &X, std::string matrix_name, std::string file_name, bool append)
    {
        std::ofstream my_file;
        if(append)
        {
            my_file.open(file_name.c_str(),std::ios::app);
        }
        else
        {
            my_file.open(file_name.c_str());
        }
        my_file << matrix_name<<"\n";
        my_file << std::scientific << std::setprecision(14) << X(0,0,0,0) <<"   "<< X(0,0,0,1) <<"   "<<X(0,0,0,2)  << "             "<<X(0,1,0,0) <<"   "<< X(0,1,0,1) <<"   "<<X(0,1,0,2)  << "             "<<X(0,2,0,0) <<"   "<< X(0,2,0,1) <<"   "<<X(0,2,0,2)  <<"\n";
        my_file << X(0,0,1,0) <<"   "<< X(0,0,1,1) <<"   "<<X(0,0,1,2)  << "             "<<X(0,1,1,0) <<"   "<< X(0,1,1,1) <<"   "<<X(0,1,1,2)  << "             "<<X(0,2,1,0) <<"   "<< X(0,2,1,1) <<"   "<<X(0,2,1,2)  <<"\n";
        my_file << X(0,0,2,0) <<"   "<< X(0,0,2,1) <<"   "<<X(0,0,2,2)  << "             "<<X(0,1,2,0) <<"   "<< X(0,1,2,1) <<"   "<<X(0,1,2,2)  << "             "<<X(0,2,2,0) <<"   "<< X(0,2,2,1) <<"   "<<X(0,2,2,2)  <<"\n";
        my_file << X(1,0,0,0) <<"   "<< X(1,0,0,1) <<"   "<<X(1,0,0,2)  << "             "<<X(1,1,0,0) <<"   "<< X(1,1,0,1) <<"   "<<X(1,1,0,2)  << "             "<<X(1,2,0,0) <<"   "<< X(1,2,0,1) <<"   "<<X(1,2,0,2)  <<"\n";
        my_file << X(1,0,1,0) <<"   "<< X(1,0,1,1) <<"   "<<X(1,0,1,2)  << "             "<<X(1,1,1,0) <<"   "<< X(1,1,1,1) <<"   "<<X(1,1,1,2)  << "             "<<X(1,2,1,0) <<"   "<< X(1,2,1,1) <<"   "<<X(1,2,1,2)  <<"\n";
        my_file << X(1,0,2,0) <<"   "<< X(1,0,2,1) <<"   "<<X(1,0,2,2)  << "             "<<X(1,1,2,0) <<"   "<< X(1,1,2,1) <<"   "<<X(1,1,2,2)  << "             "<<X(1,2,2,0) <<"   "<< X(1,2,2,1) <<"   "<<X(1,2,2,2)  <<"\n";
        my_file << X(2,0,0,0) <<"   "<< X(2,0,0,1) <<"   "<<X(2,0,0,2)  << "             "<<X(2,1,0,0) <<"   "<< X(2,1,0,1) <<"   "<<X(2,1,0,2)  << "             "<<X(2,2,0,0) <<"   "<< X(2,2,0,1) <<"   "<<X(2,2,0,2)  <<"\n";
        my_file << X(2,0,1,0) <<"   "<< X(2,0,1,1) <<"   "<<X(2,0,1,2)  << "             "<<X(2,1,1,0) <<"   "<< X(2,1,1,1) <<"   "<<X(2,1,1,2)  << "             "<<X(2,2,1,0) <<"   "<< X(2,2,1,1) <<"   "<<X(2,2,1,2)  <<"\n";
        my_file << X(2,0,2,0) <<"   "<< X(2,0,2,1) <<"   "<<X(2,0,2,2)  << "             "<<X(2,1,2,0) <<"   "<< X(2,1,2,1) <<"   "<<X(2,1,2,2)  << "             "<<X(2,2,2,0) <<"   "<< X(2,2,2,1) <<"   "<<X(2,2,2,2)  <<"\n";

        my_file.close();

    };
};

