//
// C++ Interface: dG3D domain with enhanced strain
//
// Description: Interface class for dg 3D
//
// Author:  <V.-D. NGUYEN>, (C) 2017
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef DG3DENHANCEDDOMAIN_H_
#define DG3DENHANCEDDOMAIN_H_

#include "dG3DDomain.h"

class dG3DEnhancedDomain : public dG3DDomain{
	protected:
	
	
	public:
		dG3DEnhancedDomain(const int tag, const int phys, const int sp_, const int lnum, const int fdg, const int dim);
		#ifndef SWIG
		dG3DEnhancedDomain(const dG3DEnhancedDomain &source): dG3DDomain(source){};
		virtual ~dG3DEnhancedDomain(){};
		
		virtual void createTerms(unknownField *uf,IPField*ip);
		virtual void computeStrain(MElement *e, const int npts_bulk, IntPt* GP,
                             AllIPState::ipstateElementContainer *vips,
                             IPStateBase::whichState ws, fullVector<double> &disp, bool useFBar) const;
		
		virtual partDomain* clone() const {return new dG3DEnhancedDomain(*this);};
		#endif // SWIG
};

#endif // DG3DENHANCEDDOMAIN_H_
